#include "event.h"
#define  ADD  1
#define  SUB  2 
#define  MUL  3 
#define  DIV  4

main() {

  event_type *alpha, *beta;
  int a
  
  initialize_count();
  if a = adjust(75,alpha,beta) printf("OK")
  print_stats();
  initialize_count();
  }

/*
procedure main()
  local alpha, beta

  alpha := event( 1, 500, distribution( 0, 0, make_norm() ))
  beta := event( 1, 500, distribution( 0, 0, make_norm() ))
  initialize_count()
  if a := adjust(75,alpha,beta) then write("OK")
  print_stats()
  initialize_count()
  if adjust(75,a[1],a[2]) then write("OK")
  print_stats()

  initialize_count()
  alpha := event( 1, 500, distribution( 0, 0, make_norm() ))
  alpha := shrink_l(50, alpha)
  print_stats()
  initialize_count()
  alpha := shrink_r(50, alpha)
  print_stats()

end
*/

int copyevent(event) 
event_type *event;
{
  }
/*
procedure copyevent(evnt)
  local newdist, newevnt

  newdist := distribution(evnt.dist.lo, evnt.dist.ro, evnt.dist.norm)
  newevnt := event(evnt.start, evnt.finish, newdist) 
  return newevnt
end
*/

boolean shrink_l(gamma,packed_event)
event_type *gamma; 
event_type *copyevnt; 
{

  short       lo;
  short       ro;
  float       tmp;
  dist       *distribution;
  startprob  *starting_distribution_table;
  unpackedevent_type *event;

  TEST(event = unpackevent(packedevent),"unpack event failed");

  /* Should we shrink? */
  if gamma == 0 {
    return packed_event;
    }

  /* Shrink to maximum? */
  if gamma == 100 {
    MAKE_DETERMINATE(event);
    return packevent(event);
    }

  /* Uniform Distribution? */
  if event.uniform {
    return packevent(event);
    }

  /* Non Uniform Distribution */

  /* Scale the confidence -- 
	 newgamma = gamma * [(100 - (LO + RO))/100] + LO */

    /* x := (100 - (LO + RO)) / 100 */
    lo  := LEFT_OFFSET(event);
    ro  := RIGHT_OFFSET(event);
    tmp := div_by_100[100 - lo + ro];
  
    /* ngamma = gamma * x + LO */
    tmp := gamma * tmp + lo;

  /* Figure out which superchronon is confidence */
    /* offset sc */
    startprob = get_startprob(event.dist);
    osc = startprob[floor(ngamma)];

    /* from sc */
    fsc = startprob[lo + 1];

    /* to sc */
    tsc = startprob[100 - ro];

    event = map_sc_to_chr(osc,fsc,tsc,event);
  
    printf("New Chronon is %s", dump_event(event));
  
    LEFT_OFFSET(event) := gamma + lo;
    return packevent(event);
  }

/*
procedure shrink_l( gamma, copyevnt )
  local tmp, c, ngamma, osc, fsc, tsc, sc, chr, lo, ro

  evnt := copyevent(copyevnt)

  # ------------ Figure out which superchronon is confidence
  osc := evnt.dist.norm.SP[integer(ngamma)]  #offset sc
  lo := add(evnt.dist.lo,1)
  fsc := evnt.dist.norm.SP[lo]              #from sc
  ro := sub(100,evnt.dist.ro)
  tsc := evnt.dist.norm.SP[ro]              #to sc
  # ------------ 

  chr := map_sc_to_chr(osc,fsc,tsc,evnt.start,evnt.finish)
  
  write("New Chronon is " || integer(chr))
  
  evnt.dist.lo := add(evnt.dist.lo,gamma)
  evnt.start := integer(chr)
  return evnt
end

procedure shrink_r( gamma, copyevnt )
  local tmp, c, ngamma, osc, fsc, tsc, sc, chr, lo, ro

  evnt := copyevent(copyevnt)

  #------------- Map of GAMMA
  # is  newgamma = gamma * [(100 - (LO + RO))/100] + LO

  # Table lookup
  # c := (100 - (LO + RO)) / 100
  tmp := add(evnt.dist.lo,evnt.dist.ro)
  tmp := sub(100.0,tmp)
  c   := div(tmp,100.0)  # table lookup

  # ngamma = (100 - RO) - gamma * c 
  tmp := mul(gamma,c)
  ngamma := sub(100,evnt.dist.ro)
  ngamma := sub(ngamma,tmp)

  #------------- End Map of GAMMA 

  # ------------ Figure out which superchronon is confidence
  osc := evnt.dist.norm.SP[integer(ngamma)]  #offset sc
  lo := add(evnt.dist.lo,1)
  fsc := evnt.dist.norm.SP[lo]              #from sc
  ro := sub(100,evnt.dist.ro)
  tsc := evnt.dist.norm.SP[ro]              #to sc
  # ------------ 

  chr := map_sc_to_chr(osc,fsc,tsc,evnt.start,evnt.finish)
  
  write("New Chronon is " || integer(chr))
  
  evnt.dist.ro := add(evnt.dist.ro,gamma)
  evnt.finish:= integer(chr)
  return evnt
end

procedure adjust(gamma, copyalpha, copybeta)
  local tmp

  alpha := copyevent(copyalpha)
  beta := copyevent(copybeta)
  if alpha.finish <= beta.start then return[alpha,beta]

  #delta := find_delta(1, gamma, alpha, beta) 
  #writes("Delta is " || delta) 

  delta := 75
  newalpha := shrink_r(delta,alpha)
  newbeta := shrink_l(delta,beta)
  if newalpha.finish <= newbeta.start then return[newalpha,newbeta]
  fail
end

procedure find_delta(low, high, copyalpha, copybeta)

  write("high is " || high || " low is " || low)

  alpha := copyevent(copyalpha)
  beta := copyevent(copybeta)
  if (high - low) <= 1 then return high

  tmp := integer((high - low)/2.0) + low 
  newalpha := shrink_r(tmp,alpha)
  newbeta := shrink_l(tmp,beta)
  if newalpha.finish <= newbeta.start then return find_delta(low,tmp,alpha,beta)
  else return find_delta(tmp,high,alpha,beta)
end

# ------------ Map SuperChronon to Chronon
procedure map_sc_to_chr(sc,fsc,tsc,fchr,tchr)
  local scoffset, scrange, chrrange, chr, nsc, tmp

  scoffset := sub(sc,fsc)
  scrange := sub(tsc,fsc)
  chrrange := sub(tchr,fchr)

  tmp := div(256.0,scrange)   # table lookup
  nsc := mul(tmp,scoffset)

  
  tmp := mul(nsc,chrrange)
  tmp := div(tmp,256.0)
  chr := add(fchr,tmp)

  return integer(chr)
end 

# ------------ Map Chronon to Super Chronon
procedure map_chr_to_sc(chr,fchr,tchr,fsc,tsc)
  local chroffset, scrange, chrrange, sc, 
	nchr, tmp, chrpsc, scpssc

  chroffset := sub(chr,fchr)
  chrrange := sub(tchr,fchr)
  scrange := sub(tsc,fsc)

  chrpsc := div(chrrange,256.0)  # shift
  scpssc := div(256.0,scrange)   # table lookup

  nchr := mul(chrpsc,chroffset)
  
  tmp := mul(nsc,chrrange)
  tmp := div(tmp,256.0)
  chr := add(fchr,tmp)

  return integer(chr)
end 

procedure print_stats()
  write("ADD = "||ADD||" SUB = "||SUB||" MUL = "||MUL||" DIV = "||DIV)
end

procedure make_norm()
  local norm

  norm := probability(make_SP(),make_TP(),make_PR())
  return norm
end

procedure make_SP()
  local sp

  sp := table(0)
  every i := 1 to 100 do {
    sp[i] := i * 2.56
    }
  return sp
end

procedure make_TP()
  local tp

  tp := table(0)
  every i := 1 to 100 do {
    tp[i] := 100 - ((i - 1) * 2.56)
    }
  return tp
end

procedure make_PR()
  local pr

  pr := table(0)
  every i := 1 to 100 do {
    pr[i] := 2.56
    }
  return tp
end

procedure add(x,y)
  ADD +:= 1
  #write("add " || x || " + " || y || " = " || x + y)
  return x + y
end

procedure sub(x,y)
  SUB +:= 1
  #write("sub " || x || " - " || y || " = " || x - y)
  return x - y
end

procedure mul(x,y)
  MUL +:= 1
  #write("mul " || x || " * " || y || " = " || x * y)
  return x * y
end

procedure div(x,y)
  DIV +:= 1
  #write("div " || x || " / " || y || " = " || x / y)
  return x / y
end
*/
