/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/tadt/test/leap_second_test.c
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
/* Add a print statement to tadt_malloc */
#include <stdio.h>
#include <sys/time.h>
#include "system_wide.h"
#include "tadt.h"

void main() {
  seconds_space_type junk;
  int result = 0;

  junk.seconds = 1;
  tadt_leap_seconds_in(&junk, &result);
  printf("%d\n",result);
  junk.seconds = 78796799;
  tadt_leap_seconds_in(&junk, &result);
  printf("%d\n",result);
  junk.seconds = 78796800;
  tadt_leap_seconds_in(&junk, &result);
  printf("%d\n",result);
  junk.seconds = 78796801;
  tadt_leap_seconds_in(&junk, &result);
  printf("%d\n",result);
  junk.seconds = 184694400;
  tadt_leap_seconds_in(&junk, &result);
  printf("%d\n",result);
  junk.seconds = 678412799;
  tadt_leap_seconds_in(&junk, &result);
  printf("%d\n",result);
  junk.seconds = 678412801;
  tadt_leap_seconds_in(&junk, &result);
  printf("%d\n",result);
}
