/*
#define TESTING
#define BIN_SEARCH_TESTING
*/

  static int free_nodes, occupied_nodes;
  static node_space_type nodes[DIST_MAX*2];
  void printf();
  extern dist_type distributions[MAX_DISTRIBUTION];

  unsigned short mid;
  int  target, mal_target,
       i, left, right, probe, test, range;
  node_type t, dest;
  event_aux_space_type alpha, beta;
  /*
  long long astart, bstart, afinish, bfinish;
  unsigned long long arangell, brangell, maxrangell;
  long long min;
  */
  long astart, bstart, afinish, bfinish;
  unsigned long arangell, brangell, maxrangell;
  long min;

  int aleft, aright, amid;
  int bleft, bright;
  dist_type adist, bdist;
  int amidfloor, amidceil, bmidfloor, bmidceil;
  int reversed, shift, temp;
  int adjustment;
  unsigned long rangeconstant;
  unsigned long arange, brange, maxrange;
  event_type tmp_ptr;

  /* Determine if the events overlap */
  if (tadt_e_precedes_e((event_type) &ev2->upack_ind.upper,(event_type) &ev1->upack_ind.lower)) return FALSE;
  if (tadt_e_precedes_e((event_type) &ev1->upack_ind.upper,(event_type) &ev2->upack_ind.lower)) return TRUE;

  /* Assert --> The periods of indeterminacy must overlap */

  /* Need a determinate before?*/ 
  if (gamma == 100) return FALSE;

  /* Is the indeterminacy trivial? */ 
  if (gamma == 1) return TRUE;

  target = gamma * GAMMA_MULT; 
  mal_target = (100 - gamma) * GAMMA_MULT; 

  /*
  printf(" targ %d mal %d\n", target, mal_target);
  */

  /* set up start and finish values */
  tmp_ptr = (event_type)&ev1->upack_ind.lower;
  astart = tmp_ptr->upack32.granules;
  tmp_ptr = (event_type)&ev1->upack_ind.upper;
  afinish = tmp_ptr->upack32.granules;
  tmp_ptr = (event_type)&ev2->upack_ind.lower;
  bstart = tmp_ptr->upack32.granules;
  tmp_ptr = (event_type)&ev2->upack_ind.upper;
  bfinish = tmp_ptr->upack32.granules;
  adist = distributions[ev1->upack_ind.distribution.name];
  bdist = distributions[ev2->upack_ind.distribution.name];

  /* determine ranges */
  arangell = (afinish - astart) + 1;
  brangell = (bfinish - bstart) + 1;

  maxrangell = (arangell > brangell)? arangell: brangell;

  /* Adjust range to get OK */
  shift = 0;
  for (;maxrangell > 0xFFFFFFFF; shift +=16) maxrangell = maxrangell >> 16;  
  maxrange = maxrangell;
  if (maxrange > 0x10000) 
    for (;maxrange > 0x10000; shift++) maxrange = maxrange >> 1;  
  else
    for (;maxrange < 0x10000; shift--) maxrange = maxrange << 1;  

  min = (astart < bstart)? astart: bstart;

  reversed = (arangell < brangell)? 1: 0;

  if (shift > 0) {
    brange = brangell >> shift;
    arange = arangell >> shift;
    if (reversed) {
      aleft = (bstart - min) >> shift;
      aright = (bfinish - min) >> shift;
      bleft = (astart - min) >> shift;
      bright = (afinish - min) >> shift;
      temp = brange;
      brange = arange;
      arange = temp;
      }
    else {
      aleft = (astart - min) >> shift;
      aright = (afinish - min) >> shift;
      bleft = (bstart - min) >> shift;
      bright = (bfinish - min) >> shift;
      }
    }
  else {
    shift = shift*(-1);
    arange = arangell << shift;
    brange = brangell << shift;
    if (reversed) {
      aleft = (bstart - min) << shift;
      aright = (bfinish - min) << shift;
      bleft = (astart - min) << shift;
      bright = (afinish - min) << shift;
      temp = brange;
      brange = arange;
      arange = temp;
      }
    else {
      aleft = (astart - min) << shift;
      aright = (afinish - min) << shift;
      bleft = (bstart - min) << shift;
      bright = (bfinish - min) << shift;
      }
    }

  if (aleft) { if (brange) adjustment = (aleft<< 16)/brange; else adjustment = 0;}
  else adjustment = (-1) * ((bleft << 16)/brange);
  rangeconstant = arange/brange;

#ifdef TESTING
printf("reversed %d arange %d aleft %d aright %d\n brange %d bleft %d bright %d\n", 
        reversed, arange, aleft, aright, brange, bleft, bright);
#endif

  free_nodes = 1;
  occupied_nodes = 0;
  t = &nodes[occupied_nodes]; 
  t->alpha.from = DIST_MIN;
  t->alpha.to = DIST_MAX;
  t->alpha.prob = DIST_MAX;
  t->beta.from = DIST_MIN;
  t->beta.to = DIST_MAX;
  t->beta.prob = DIST_MAX;

  do {

    /* Error Testing */
    if (occupied_nodes > DIST_MAX) {
       for(i=0;i<occupied_nodes;i++) {
	 printf("a %d af %d at %d b %d bf %d bt %d\n", 
	  nodes[i].alpha.prob,
	  nodes[i].alpha.from,
	  nodes[i].alpha.to,
	  nodes[i].beta.prob,
	  nodes[i].beta.from,
	  nodes[i].beta.to);
	  }
       printf("%d \n", occupied_nodes);
       exit(1);
       }

    /* Get a node */
    t = &nodes[occupied_nodes]; 
    occupied_nodes++;

    /* Choose a pivot by halving alpha's (assuming alpha has the smaller
       superchronon range) probability */
    bright = t->beta.to;
    bleft = t->beta.from;
    brange = (bright - bleft)+1;
    aright = t->alpha.to;
    aleft = t->alpha.from;
    arange = (aright - aleft)+1;
    amid = arange/2;
    alpha.prob_left = amid;
    alpha.prob_right = arange - amid;

    /* Translate left side of alpha superchronon to beta superchronon */
    amidfloor = adist->floor[aleft + amid];
    bmidfloor = (amidfloor * rangeconstant) + adjustment;

    /* Translate right side of alpha superchronon to beta superchronon */
    amidceil = adist->ceiling[aleft + amid];
    bmidceil = (amidceil * rangeconstant) + adjustment;

    /* Add stuff here - Special Cases */
    /*
    if (bmidceil > MAX_SC) bmid = MAX_SC;
    if (bmidfloor < MIN_SC) bmid = MIN_SC;
    */

#ifdef TESTING
printf("amid %d rangeconstant %d adjustment %d bmid %d\n", amid, rangeconstant, adjustment, mid);
#endif

    /* Binary search to find the probability in beta just below the probe */
    left = bleft;
    right = bright;
    probe = bmidceil;
    for (range = right - left; range > 1; range = right-left) {

      mid  = (range >> 1) + left;
      test = bdist->ceiling[mid];
      if (test > probe) {
        right = mid;
        }
      else {
        left = mid;
        }

#ifdef BIN_SEARCH_TESTING
printf("test %d probe %d range %d mid %d left %d right %d\n", 
test, probe, range, mid, left, right);
#endif

      }

    beta.prob_left = left - bleft;

    /* Figure out other intersect */
    /* Binary search to find the probability in beta just above the probe */
    left = bleft;
    right = bright;
    probe = bmidfloor;
    for (range = right-left; range > 1; range = right-left) {

      mid  = (range >> 1) + left;
      test = bdist->floor[mid];
      if (test > probe) {
        right = mid;
        }
      else {
        left = mid;
        }

#ifdef BIN_SEARCH_TESTING
printf("test %d probe %d range %d mid %d left %d right %d\n", 
test, probe, range, mid, left, right);
#endif

      }

    beta.prob_right = bright - right;

#ifdef TESTING
printf("bf %d bt %d br %d bl %d bmf %d bmc %d\n", 
       bleft, bright, beta.prob_right, beta.prob_left, bmidfloor, bmidceil);

printf("af %d at %d ar %d al %d amf %d amc %d \n", 
       aleft, aright, alpha.prob_right, alpha.prob_left, amidfloor, amidceil);

printf("mid %d target %d mal_target %d\n", mid, target, mal_target);
#endif

    mal_target -= alpha.prob_right * beta.prob_left; 
    target -= alpha.prob_left * beta.prob_right; 

    /* Satisfied? */
    /*
    if (target < 0) return !reversed;
    */
    if (target < 0) {
      /*
      printf("good pivots %d %d\n", free_nodes, reversed);
      */
      return !reversed;
      }

    /* Opposite proved? */
    if (mal_target < 0) {
      /*
      printf("mal pivots %d %d\n", free_nodes, reversed);
      */
      return reversed;
      }

    if (beta.prob_left && (alpha.prob_left >> 1)) {
      dest = &nodes[free_nodes];
      dest->alpha.from = aleft;
      dest->alpha.to = aleft + amid - 1;
      dest->alpha.prob = alpha.prob_left;
      dest->beta.from = bleft;
      dest->beta.to = bright - beta.prob_right; 
      dest->beta.prob = beta.prob_left;
      free_nodes++;
      }

    if (beta.prob_right && (alpha.prob_right >> 1)) {
      dest = &nodes[free_nodes];
      dest->alpha.from = aleft + amid;
      dest->alpha.to = aright;
      dest->alpha.prob = alpha.prob_right;
      dest->beta.from = bleft + beta.prob_left;
      dest->beta.to = bright;
      dest->beta.prob = beta.prob_right;
      free_nodes++;
      }

    } while (occupied_nodes != free_nodes);
 /*
 printf("mid %d target %d mal_target %d free nodes %d\n", mid, target, mal_target, free_nodes);
 */
  return FALSE;
